unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EAnzahl: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    ETreffer: TEdit;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Timer1: TTimer;
    Button5: TButton;
    Label7: TLabel;
    LGeschwindigkeit: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    Anzahl :Integer;
    Treffer:Integer;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Anzahl:=0;
  Treffer:=0;
  timer1.Interval:=512; //ca 1/2 Sekunte
end;

function doppelsechs:boolean; //Der erste Wurf=6 und der zweite Wurf=6
begin
  result:=(random(6)=5) and (random(6)=5)
  //random(6) liefert ganze Zahlen von 0 bis 5 mit gleicher Wahrscheinlichkeit
  //0 entspricht Wrfel=1 ... 5 entspricht Wrfel=6
end;

function TrefferImExperiment:integer;
  var i:integer;
begin
  for i:=1 to 24 do
    if doppelsechs then Begin
      result:=1; //Treffer
      exit;
    End;
  result:=0; //in 48 Wrfen keine Doppelsechs
end;



procedure TForm1.Timer1Timer(Sender: TObject);
  var j:integer;
      n:Cardinal;
begin
  eAnzahl.Text:=IntToStr(Anzahl);
  if Treffer>0 then eTreffer.text:=FormatFloat('###.####',treffer/Anzahl*100)+'%';
  if timer1.interval=1 then n:=4096 else
    if timer1.interval<=8 then n:=64 else
      if timer1.interval<=64 then n:=8 else n:=1;
  if n=4096 then LGeschwindigkeit.Caption:='Maximum' else
    LGeschwindigkeit.Caption:='maximal:'+IntToStr(1024*n div timer1.interval);
  for j:=1 to n do Begin  //Gleich n Versuche
    inc(Anzahl);
    treffer:=treffer+TrefferImExperiment;
  End;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if timer1.interval>1 then timer1.interval:=timer1.interval div 2;

end;

procedure TForm1.Button4Click(Sender: TObject);
  const s='       Theorie'#13+
          'In 24 Versuchen kein Treffer (35/36)^24=50,86%'#13+
          'In 24 Versuchen mindestens ein Treffer 49,14%';
begin
  showmessage(s);
  close
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  timer1.Interval:=0;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  timer1.Interval:=500;
end;

end.
